from typing import Optional, List
from datetime import datetime

from runai import models
from runai.api.runai_api_service import RunaiAPIService, deprecated_message


class StorageClassesApi(RunaiAPIService):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        self._api_client = api_client

    def get_storage_classes(
        self,
        uuid: str,
    ):
        r"""


        ### Description
        Get all storageClasses from a cluster.

        ### Parameters:
        ```python
        uuid: str
        ```
        uuid: Unique identifier of the cluster

        ### Example:
        ```python
        StorageClassesApi(
            uuid='uuid_example'
        )
        ```
        """

        resource_path = f"/v1/k8s/clusters/{uuid}/storage_classes".replace("_", "-")
        method = "GET"
        return self._api_client.call_api(
            resource_path=resource_path,
            method=method,
        )
