# coding: utf-8

"""
    Runai API

    # Introduction  The Run:AI Control-Plane API reference is a guide that provides an easy-to-use programming interface for adding various tasks to your application, including workload submission, resource management, and administrative operations.  Run:ai APIs are accessed using *bearer tokens*. To obtain a token, you need to create an **Application** through the Run:ai user interface. To create an application, in your UI, go to `Settings & Tools`, `Application` and create a new Application.  After you have created a new application, you will need to assign it access rules. To assign access rules to the application, see [Create access rules](https://docs.run.ai/latest/admin/runai-setup/access-control/rbac/?h=create+delete+app#create-or-delete-rules). Make sure you assign the correct rules to your application. Use the [Roles](https://docs.run.ai/latest/admin/runai-setup/access-control/rbac/?h=create+delete+app#roles) to assign the correct access rules.  To get your access token, follow the instructions in [Request a token](https://docs.run.ai/latest/developer/rest-auth/#request-an-api-token). 

    The version of the OpenAPI document: 2.18
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from runai.models.host_paths_rules import HostPathsRules
from runai.models.nfss_rules import NfssRules
from runai.models.s3s_rules import S3sRules
from typing import Optional, Set
from typing_extensions import Self


class NonInferenceStorageFieldsRules(BaseModel):
    """
    Pydantic class model representing NonInferenceStorageFieldsRules.

    Parameters:
        ```python
        host_path: Optional[HostPathsRules]
        nfs: Optional[NfssRules]
        s3: Optional[S3sRules]
        ```
        host_path: See model HostPathsRules for more information.
        nfs: See model NfssRules for more information.
        s3: See model S3sRules for more information.
    Example:
        ```python
        NonInferenceStorageFieldsRules(
            host_path=runai.models.host_paths_rules.HostPathsRules(
                    attributes = runai.models.host_path_rules.HostPathRules(
                        path = runai.models.string_rules.StringRules(),
                        read_only = runai.models.boolean_rules.BooleanRules(
                            source_of_rule = {"scope":"project","projectId":3},
                            required = True,
                            can_edit = True, ),
                        mount_path = runai.models.string_rules.StringRules(),
                        mount_propagation = runai.models.host_path_mount_propagation_rules.HostPathMountPropagationRules(), ),
                    instances = runai.models.item_rules.ItemRules(
                        can_add = True,
                        locked = ["HOME","USER"], ), ),
                        nfs=runai.models.nfss_rules.NfssRules(
                    attributes = runai.models.nfs_rules.NfsRules(
                        path = runai.models.string_rules.StringRules(),
                        read_only = runai.models.boolean_rules.BooleanRules(
                            source_of_rule = {"scope":"project","projectId":3},
                            required = True,
                            can_edit = True, ),
                        server = runai.models.string_rules.StringRules(),
                        mount_path = runai.models.string_rules.StringRules(), ),
                    instances = runai.models.item_rules.ItemRules(
                        can_add = True,
                        locked = ["HOME","USER"], ), ),
                        s3=runai.models.s3s_rules.S3sRules(
                    attributes = runai.models.s3_rules.S3Rules(
                        bucket = runai.models.string_rules.StringRules(),
                        path = runai.models.string_rules.StringRules(),
                        url = runai.models.string_rules.StringRules(), ),
                    instances = runai.models.item_rules.ItemRules(
                        source_of_rule = {"scope":"project","projectId":3},
                        can_add = True,
                        locked = ["HOME","USER"], ), )
        )
        ```
    """  # noqa: E501

    host_path: Optional[HostPathsRules] = Field(default=None, alias="hostPath")
    nfs: Optional[NfssRules] = None
    s3: Optional[S3sRules] = None
    __properties: ClassVar[List[str]] = ["hostPath", "nfs", "s3"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NonInferenceStorageFieldsRules from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of host_path
        if self.host_path:
            _dict["hostPath"] = self.host_path.to_dict()
        # override the default output from pydantic by calling `to_dict()` of nfs
        if self.nfs:
            _dict["nfs"] = self.nfs.to_dict()
        # override the default output from pydantic by calling `to_dict()` of s3
        if self.s3:
            _dict["s3"] = self.s3.to_dict()
        # set to None if host_path (nullable) is None
        # and model_fields_set contains the field
        if self.host_path is None and "host_path" in self.model_fields_set:
            _dict["hostPath"] = None

        # set to None if nfs (nullable) is None
        # and model_fields_set contains the field
        if self.nfs is None and "nfs" in self.model_fields_set:
            _dict["nfs"] = None

        # set to None if s3 (nullable) is None
        # and model_fields_set contains the field
        if self.s3 is None and "s3" in self.model_fields_set:
            _dict["s3"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NonInferenceStorageFieldsRules from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "hostPath": (
                    HostPathsRules.from_dict(obj["hostPath"])
                    if obj.get("hostPath") is not None
                    else None
                ),
                "nfs": (
                    NfssRules.from_dict(obj["nfs"])
                    if obj.get("nfs") is not None
                    else None
                ),
                "s3": (
                    S3sRules.from_dict(obj["s3"]) if obj.get("s3") is not None else None
                ),
            }
        )
        return _obj
